
--this shader substracts alpha of the eraser brush
--offset calculation still incorrect

function love.load()

	offset={}
	offset.x=400.0
	offset.y=400.0

	circle=love.graphics.newImage('circle.png')

	cvs1=love.graphics.newCanvas(640,480)
	love.graphics.setCanvas(cvs1)
	--first canvas is filled with redmod
	love.graphics.clear(1.0,0.0,0.0,1.0)

	--the canvas holding the real image data
	curcvs=cvs1

	
	cvs2=love.graphics.newCanvas(640,480)
	love.graphics.setCanvas(cvs2)
	love.graphics.clear(0.0,0.0,0.0,0.0)

	backcvs=cvs2 -- the back buffer the frag shader will render to

	love.graphics.setCanvas()

	local pixelcode=[[
		//second is the eraser
		extern Image second;
		extern float cvsw;
		extern float brshw;
		extern float cvsh;
		extern float brshh;
		extern float offx;//pixels
		extern float offy;//pixels

		vec4 effect(vec4 color,Image texture,vec2 tc,vec2 sc){
			
			
			vec4 texturePixel=Texel(texture,tc);
			
			
			float tcx = tc.x*cvsw/brshw - offx/cvsw;
			if (tcx>1.0 || tcx<0.0 ){
				return texturePixel;
			}
			float tcy = tc.y*cvsh/brshh-offy/cvsh;
			if (tcy>1.0 || tcy<0.0){
				return texturePixel;
			}
			vec2 rtc=vec2(tcx,tcy);
			
			vec4 secondPixel=Texel(second,rtc);
			
				vec4 ret=texturePixel ;
				ret.a=ret.a-secondPixel.a;
				return ret;
			
		}
	]]

	shader=love.graphics.newShader(pixelcode)

	shader:send("second",circle)
	shader:send("cvsw",640.0)
	shader:send("brshw",64.0)
	shader:send("cvsh",480.0)
	shader:send("brshh",64.0)
	shader:send("offx",offset.x)
	shader:send("offy",offset.y)

	--test erase from curcvs to backcvs
	love.graphics.setCanvas(backcvs)
	love.graphics.setShader(shader)
	love.graphics.draw(curcvs)
	love.graphics.setShader()
	love.graphics.setCanvas()

end


function love.draw()

	love.graphics.draw(backcvs)
	love.graphics.print('eraser shader test')


end